
/* S1 cpu micro architecture simulator

   Computer Architecture 1997

   P. Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University

   include clock counting and cpi calculation 15 Aug 97
   small change and update timing	      18 July 98
*/

#include <stdio.h>

int R[8], Ir, Mdr, Mar, Pc, T, Z, S, M[1024];
int trace, core, start, nbyte;   /* control display */

/* this is not a good style
   but make it simpler to compile */
#include "support.c"

ifetch()       	/* instruction fetch */
{
  Mar = Pc;
  Mdr = M[Mar];
  Ir = Mdr; Pc = Pc + 1;
}

ofetch()	/* operand fetch */
{
  Mar = IRads();
  Mdr = M[Mar];
}

owrite()	/* operand write */
{
  Mar = IRads();
  M[Mar] = Mdr;
}

alu(char op, int a,int b) /* alu operation input : a, b */
{                         /* affect condition code Z,S  */
  switch(op) {
  case '+': T = a+b; break;
  case '-': T = a-b; break;
  case 'c': T = a-b; break;
  }
  if( T == 0 ) Z = 1; else Z = 0;
  if( T < 0 )  S = 1; else S = 0;
}

testCc(int cond )	/* test condition code */
{
  switch( cond ) {    	/*  -,z,nz,lt,le,ge,gt */
  case 0: return 1;	/*  0,1, 2, 3, 4, 5, 6 */
  case 1: return Z;
  case 2: return !Z;
  case 3: return S;
  case 4: return S || Z;
  case 5: return !S || Z;
  case 6: return !S;
  }
  return 0;
}

run()		/* decode and execute */
{
  while( 1) {
    ifetch();
    countclock();
    switch( IRop() ) {
    case 0: ofetch();		/* load r, ads */
	    R[IRr()] = Mdr;
	    break;
    case 1: Mdr = R[IRr()];	/* store r, ads */
	    owrite();
	    break;
    case 2: if( testCc(IRr()) ) /* jump c, ads */
	      Pc = IRads();
	    break;
    case 3: if( trap(IRads()) ) break;
	    alu('+',R[7],1);	/* call ads */
	    R[7] = T;
	    Mar = R[7];
	    Mdr = Pc;
	    M[Mar] = Mdr;
	    Pc = IRads();
	    break;
    case 7: xop();              /* extended op */
    }
    if( trace ) show();
  }
}

xop()
{
  switch( IRxop() ) {
  case 0: T = R[ IRr1() ];		/* mov r1, r2 */
	  R[ IRr2() ] = T;
	  break;
  case 1: Mar = R[ IRr1() ];		/* load (r1), r2 */
	  Mdr = M[Mar];
	  R[ IRr2() ] = Mdr;
	  break;
  case 2: Mar = R[ IRr2() ];    	/* store r1, (r2) */
	  Mdr = R[ IRr1() ];
	  M[Mar] = Mdr;
	  break;
  case 3: alu('+',R[IRr1()],R[IRr2()]); /* add r1, r2 */
	  R[ IRr1() ] = T;
	  break;
  case 4: alu('c',R[IRr1()],R[IRr2()]); /* cmp r1, r2 */
	  break;
  case 5: alu('+',R[IRr1()],1);		/* inc r1 */
	  R[ IRr1() ] = T;
	  break;
  case 6: Mar = R[7];			/* ret */
	  Mdr = M[Mar];
	  Pc = Mdr;
	  alu('-', R[7],1);
	  R[7] = T;
	  break;
  case 7: alu('+', R[7],1);		/* push r1 */
	  R[7] = T;
	  Mar = R[7];
	  Mdr = R[ IRr1() ];
	  M[Mar] = Mdr;
	  break;
  case 8: Mar = R[7];			/* pop r1 */
	  Mdr = M[Mar];
	  R[ IRr1() ] = Mdr;
	  alu('-',R[7],1);
	  R[7] = T;
	  break;
  }
}

main()
{
  trace = 0;
  core = 0;
  loadprogram();
  clock = 0;
  ninst = 0;
  Pc = 0;
  Z = 0;
  S = 0;
  run();
}
