/* S1 cpu simulator
   Computer Architecture 1997

   supporting function

   P. Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University

   include clock counting and cpi calculation 15 Aug 97
*/

int itime[] = { 6,6,5,9, 0,0,0,  /* load,store,jmp,call,-,-,- */
		5,6,6,5,         /* mov, mov (r), mov r (r), add, */
		4,5,8,8,8 };     /* cmp,inc,ret,push,pop */
int clock, ninst;

countclock()
{
  int inst;
  if( IRop() == 7 )
    inst = 7 + IRxop();
  else
    inst = IRop();
  clock += itime[inst];
  ninst++;
}

report()
{
  float cpi;
  cpi = ((float) clock)/ninst;
  printf("%d instructions %d clocks CPI = %f\n",
	 ninst,clock,cpi);
}

/* IR decode */
IRop() { return( ( Ir & 0xE000 ) >> 13 ); } /* bit 15..13 */
IRr()  { return( ( Ir & 0x1C00 ) >> 10 ); } /* bit 12..10 */
IRads(){ return(   Ir & 0x03FF         ); } /* bit 9..0   */
IRxop(){ return( ( Ir & 0x1E00 ) >> 9  ); } /* bit 12..9  */
IRr1() { return( ( Ir & 0x0038 ) >> 3  ); } /* bit 5..3   */
IRr2() { return(   Ir & 0x0007         ); } /* bit 2..0   */

trap( ads )			/* special function */
int ads;
{
  switch( ads ) {
  case 1000 : if( core ) dump(start,nbyte);
	      report();
	      exit(0); 		    /* stop */
  case 1001 : printf("%d\n",R[0]);  /* print R0 */
	      break;
  default: return 0;
  }
  return 1;
}

/* load object code from file */

geta(fp)	/* get one charactor */
FILE *fp;	/* skip newline and blank */
{
  char s[32];
  fscanf(fp,"%s",s);
  return s[0] ;
}

geti(fp)	/* get one integer */
FILE *fp;
{
  int c;
  fscanf(fp,"%d",&c);
  return c;
}

/* set maximum of number to be read to 200
   to prevent infinite loop when input is malformed
   the input file name is fixed to "in.obj"
*/
loadprogram()
{
  int cnt,ip,c,c1,c2;
  FILE *fp;

  fp = fopen("in.obj","r");
  ip = 0;
  for(cnt=0; cnt<200; cnt++ ) {		/* max 200 words */
    switch( geta(fp) ) {
    case 'a': ip = geti(fp);		/* set address */
	break;
    case 'i': c = geti(fp);		/* instruction */
	c1 = geti(fp);
	c2 = geti(fp);
	if(c != 7)
	  M[ip] = (c << 13) | (c1 << 10) | c2;
	else
	  M[ip] = (c << 13) | (c1 << 9) | (c2 << 3) | geti(fp);
	ip++;
	break;
    case 'w': M[ip] = geti(fp);		/* set constant data */
	ip++;
	break;
    case 't': trace = 1;		/* trace mode */
	break;
    case 'd': core = 1;                 /* dump start nbyte */
	start = geti(fp);
	nbyte = geti(fp);
	break;
    case 'e': cnt = 1000;		/* end */
	break;
    }
  }
  fclose(fp);
  printf("load program, last address %d\n",ip);
}

dump(ads,n)	/* dump n words starting from ads */
int ads,n;
{
  int i;
  for(i=ads; i<ads+n; i++)
    printf("%4d %4x\n",i,M[i]);
}

show()		/* show some registers */
{
  int op, ox;
  op = IRop();
  if( op == 7 ) ox = IRxop(); else ox = 0;
  printf("PC %4d IR %4x op %d xop %d R0 %d R1 %d R2 %d R7 %d Z %d S %d\n",
	Pc,Ir,op,ox,R[0],R[1],R[2],R[7],Z,S);
}
